/*
- This code is created by Muhammad Muddassir Malik
- Animations are not tied to the time interval for simplicity purposes
- IP in variable name denotes Input (text field)
- BT in variable name denotes button
- SD in variable name denotes Slider
*/


let sun;
let earth;
let noOfStars = 100;
let sizeOfSun = 0.7;
let stars = new Array(noOfStars);
let angle = 0;
let noOfStarsIP;
let earthDistFromSunSD;

let planetEarth =  {
  size : 0.06,
  distFromSun: 200,
  rotSpeed : 1,
  revSpeed : 4,
  moonExists : true,
  moonDist : 50,
  moonRotSpeed : 1,
  moonSize : 10,
};

let planetGeneral = {
  size : 1,
  colour : 'green',
  rotSpeed : 1,
  revSpeed : 4,
  distFromSun: 200,
  moonExists : true,
  moonDist : 50,
  moonRotSpeed : 1,
  moonSize : 10,
};


function preload(){
  sun = loadImage("data/sun.png");
  earth = loadImage("data/earth.png");
}

function createStars(){
  for (let i=0;i<noOfStars;i++){
    stars[i] = createVector(int(random(width)), int(random(height)));
  }
}

function drawStars(){
  fill(255, 255, 255);
  noStroke();
  for (let i=0;i<noOfStars;i++){
    ellipse(stars[i].x, stars[i].y, 2, 2);
  }
}

function drawMoon(planet){
  fill(255, 255, 255);
  push();
    rotate(angle * planet.moonRotSpeed);
    translate(planet.moonDist, 0);
    ellipse(0, 0, planet.moonSize, planet.moonSize);
  pop();
}

function updateNoOfStars (){
  noOfStars = int(noOfStarsIP.value());
  stars = new Array(noOfStars);
  createStars();
}

function setup() {
  createCanvas(730, 730);
  createStars();
  noOfStarsIP = createInput(noOfStars);
  noOfStarsBT = createButton('submit');
  noOfStarsBT.mousePressed(updateNoOfStars);
  
  createP("");
  createDiv("Earth Parameters");
  earthDistFromSunSD = createSlider(50, 300, planetEarth.distFromSun);
  earthDistFromSunSD.style('width', '200px');
  
  rectMode(CENTER);
  angleMode(DEGREES);
  imageMode(CENTER);
}

function draw() {
  planetEarth.distFromSun = earthDistFromSunSD.value();
  
  background('black');
  drawStars();
  
  fill(255, 0, 0);
  angle += 0.25;
  
  translate(width/2, height/2);
  push();
    push();
      scale(sizeOfSun);
      image(sun, 0, 0);
    pop();
    
    rotate(angle * planetEarth.rotSpeed);
    translate(planetEarth.distFromSun, 0);
  
    push();
      rotate(-angle * planetEarth.revSpeed);
      scale(planetEarth.size);
      image(earth, 0, 0);
    pop();
  
    if (planetEarth.moonExists == true)
      drawMoon(planetEarth);
   
  pop();
}

function keyPressed() {

}
